import React from "react";
import { PostSizes } from "./Post";
import { TagsType } from "../types";
export declare const setTumblrEmbedFetcher: (fetcher: (url: string) => any) => void;
export declare const setOEmbedFetcher: (fetcher: (url: string) => any) => void;
declare const PostEditor: React.FC<PostEditorProps>;
export default PostEditor;
export interface PostEditorProps {
    initialText?: string;
    secretIdentity?: {
        avatar: string;
        name: string;
    };
    userIdentity: {
        avatar: string;
        name: string;
    };
    loading?: boolean;
    defaultSize?: PostSizes;
    onImageUploadRequest: (imgUrl: string) => Promise<string>;
    onSubmit: (postPromise: Promise<{
        text: string;
        large: boolean;
        tags?: TagsType[];
    }>) => void;
    onCancel: () => void;
    centered?: boolean;
    accentColor?: string;
}
